#include <vector>
#include <fstream>

using namespace std;

#define FOR(i, a, b) for(int i = (a); i <= (b); ++i)

struct Matrix
{
	int sor, oszlop;
	vector < vector <int> > a;
};

Matrix operator*(Matrix& x, Matrix& y)
{
	Matrix p;
	p.sor = x.sor;
	p.oszlop = y.oszlop;
	p.a.resize(x.sor + 1, vector <int> (y.oszlop + 1));
	FOR(i, 1, x.sor)
		FOR(j, 1, y.oszlop)
			FOR(k, 1, x.oszlop)
				p.a[i][j] += x.a[i][k] * y.a[k][j];
	return p;
}

ifstream fin("fel3.in");
ofstream fout("fel3.out");

int n;
vector<Matrix> matrixok;

void beolvas()
{
	fin >> n;
	matrixok.resize(n + 1);
	FOR(i, 1, n)
	{
		int sor, oszlop;
		fin >> sor >> oszlop;
		matrixok[i].sor = sor;
		matrixok[i].oszlop = oszlop;
		matrixok[i].a.resize(sor + 1, vector <int> (oszlop + 1));
		FOR(j, 1, sor)
			FOR(k, 1, oszlop)
				fin >> matrixok[i].a[j][k];
	}
}

void kiirSzorzat()
{
	Matrix p = matrixok[1];
	FOR(i, 2, n) p = p * matrixok[i];

	fout << "Szorzat:" << endl;
	FOR(i, 1, p.sor)
	{
		FOR(j, 1, p.oszlop)
			fout << p.a[i][j] << " ";
		fout << endl;
	}
			
}

void main()
{
	beolvas();
	kiirSzorzat();
}